VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4500
   ClientLeft      =   2010
   ClientTop       =   1860
   ClientWidth     =   4575
   Height          =   4905
   Left            =   1950
   LinkTopic       =   "Form1"
   ScaleHeight     =   4500
   ScaleWidth      =   4575
   Top             =   1515
   Width           =   4695
   Begin VB.CommandButton Command1 
      Caption         =   "Search"
      Default         =   -1  'True
      Height          =   495
      Left            =   3240
      TabIndex        =   5
      Top             =   3600
      Width           =   1215
   End
   Begin VB.TextBox PatternText 
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Text            =   "*.jpg"
      Top             =   3840
      Width           =   2055
   End
   Begin VB.TextBox StartText 
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Text            =   "C:"
      Top             =   3480
      Width           =   2055
   End
   Begin VB.TextBox ListText 
      Height          =   3375
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   4455
   End
   Begin VB.Label SizeLabel 
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   1080
      TabIndex        =   7
      Top             =   4200
      Width           =   285
   End
   Begin VB.Label Label2 
      Caption         =   "Total Size"
      Height          =   255
      Index           =   1
      Left            =   0
      TabIndex        =   6
      Top             =   4200
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Pattern"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   3840
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Start directory"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3480
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
Dim start_dir As String
Dim pattern As String
Dim file_list As String

    SizeLabel.Caption = ""
    ListText.Text = ""
    MousePointer = vbHourglass
    DoEvents
    
    start_dir = Trim$(StartText.Text)
    If Right$(start_dir, 1) = "\" Then _
        start_dir = _
            Left$(start_dir, Len(start_dir) - 1)
    pattern = Trim$(PatternText.Text)
    SizeLabel.Caption = Format$(ListFiles(start_dir, pattern, file_list)) & " bytes"
    ListText.Text = file_list
    MousePointer = vbDefault
End Sub
' *********************************************
' List all files below the directory that
' match the pattern.
' *********************************************
Private Function ListFiles(ByVal start_dir As String, ByVal pattern As String, file_list As String) As Double
Dim dir_names() As String
Dim num_dirs As Integer
Dim i As Integer
Dim fname As String
Dim full_name As String
Dim new_files As String
Dim attr As Integer
Dim total_size As Double

    ' Protects against such things as
    ' GetAttr("C:\pagefile.sys").
    On Error Resume Next
    
    ' Get the matching files in this directory.
    fname = Dir(start_dir & "\" & pattern, vbNormal)
    Do While fname <> ""
        full_name = start_dir & "\" & fname
        new_files = new_files & full_name & vbCrLf
        total_size = total_size + FileLen(full_name)
        fname = Dir()
    Loop
    file_list = file_list & new_files
    
    ' Optionally display the newlist here.
    
    ' Get the list of subdirectories.
    fname = Dir(start_dir & "\*.*", vbDirectory)
    Do While fname <> ""
        ' Skip this dir and its parent.
        attr = 0    ' In case there's an error.
        attr = GetAttr(start_dir & "\" & fname)
        If fname <> "." And fname <> ".." And _
            (attr And vbDirectory) <> 0 _
        Then
            num_dirs = num_dirs + 1
            ReDim Preserve dir_names(1 To num_dirs)
            dir_names(num_dirs) = fname
        End If
        fname = Dir()
    Loop
    
    ' Search the other directories.
    For i = 1 To num_dirs
        total_size = total_size + _
            ListFiles(start_dir & "\" & dir_names(i), pattern, file_list)
    Next i

    ListFiles = total_size
End Function

